<?php

// This receives the yes/no confirmation when installing
// an app and then begins the install
//
// Apps are installed by adding them to the pending_installs.txt
// file and the webadmin daemon (freedombone-installer) then
// does the actual installation in the background

function endsWith($haystack, $needle)
{
    $length = strlen($needle);
    if ($length == 0) {
        return true;
    }

    return (substr($haystack, -$length) === $needle);
}

$output_filename = "apps_add.html";

if (isset($_POST['installconfirmsubmit'])) {
    if(isset($_POST['installconfirm'])) {
        $confirm = htmlspecialchars($_POST['installconfirm']);

        if($confirm == "1") {
            $app_name = htmlspecialchars($_POST['app_name']);
            $install_domain = '';
            $freedns_code = '';

            // Note that this value can be changed by install_web_admin
            $onion_only=false;

            $continue_install=true;

            if(! $onion_only) {
                $no_domain = htmlspecialchars($_POST['no_domain']);
                if ($no_domain === '0') {
                    $install_domain = htmlspecialchars($_POST['install_domain']);
                    if (strpos($install_domain, '.') === false) {
                        // No domain was provided
                        $continue_install=false;
                    }
                }
            }

            if($continue_install) {
                if(file_exists("pending_removes.txt")) {
                    // Is this app in the pending_removes list?
                    if(exec('grep '.escapeshellarg("remove_".$app_name).' ./pending_removes.txt')) {
                        if(! exec('grep '.escapeshellarg("remove_".$app_name).'_running ./pending_removes.txt')) {
                            // Not Removing yet so remove from schedule
                            exec('sed -i "/'.escapeshellarg("remove_".$app_name).'/d ./pending_removes.txt');
                        }
                        else {
                            // Removing so don't continue
                            $continue_install=false;
                        }
                    }
                }
            }

            if($continue_install) {
                if(! file_exists("pending_installs.txt")) {
                    $pending_installs = fopen("pending_installs.txt", "w") or die("Unable to create installs file");
                    fclose($pending_installs);
                }

                if(! exec('grep '.escapeshellarg("install_".$app_name).' ./pending_installs.txt')) {
                    if(! file_exists("index_app_installing.html")) {
                        exec('cp index.html index_app_installing.html');
                        exec('cp app_installing_progress.html index.html');
                    }
                    exec('cp app_installing_progress.html installing_progress.html');
                    if(file_exists('icons/'.$app_name.'.png')) {
                        exec('cp icons/'.$app_name.'.png images/installing_app.png');
                    }
                    $pending_installs = fopen("pending_installs.txt", "a") or die("Unable to append to installs file");
                    fwrite($pending_installs, "install_".$app_name.",".$install_domain.",".$freedns_code."\n");
                    fclose($pending_installs);

                    # remain on this screen after clicking update
                    $host  = $_SERVER['HTTP_HOST'];
                    $uri   = rtrim(dirname($_SERVER['PHP_SELF']), '/\\');
                    if (endsWith($uri, 'admin')) {
                        header("Location: http://".$host.$uri);
                    }
                    else {
                        header("Location: http://".$host.$uri."/admin");
                    }

                    $output_filename = "installing_progress.html";
                }
                else {
                    // The app is already scheduled for installation
                    $output_filename = "app_scheduled.html";
                }
            }
        }
    }
}

$htmlfile = fopen("$output_filename", "r") or die("Unable to open $output_filename");
echo fread($htmlfile,filesize("$output_filename"));
fclose($htmlfile);

// remove confirm screen
if(file_exists("add_app_confirm.html")) {
    exec('rm add_app_confirm.html');
}

?>
